﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private btnTakePicture As Button
	Private cam As CamEx2
	Private panelCamera As Panel
	Private ImageView1 As ImageView	 'Holds taken Image
	
	Private rp As RuntimePermissions
	Private MyTaskIndex As Int
	
	Private VideoFileDir  As String
End Sub

Public Sub Initialize
	'Return Me  ??
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("sendpicture")
	B4XPages.SetTitle(Me, "Take a Clear Picture")
	
	cam.Initialize(panelCamera)
	OpenCamera(True)
End Sub

Private Sub btnTakePicture_Click
	VideoFileDir = rp.GetSafeDirDefaultExternal("")
	Log(cam.SupportedHardwareLevel)

	TakePicture
End Sub

Sub OpenCamera (front As Boolean)
	rp.CheckAndRequest(rp.PERMISSION_CAMERA)
	Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
	If Result = False Then
		ToastMessageShow("No permission!", True)
		Return
	End If

	Wait For (cam.OpenCamera(front)) Complete (TaskIndex As Int)
	If TaskIndex > 0 Then
		MyTaskIndex = TaskIndex 'hold this index. It will be required in later calls.
		Wait For(PrepareSurface) Complete (Success As Boolean)
	End If
	Log("Start success: " & Success)
	If Success = False Then
		ToastMessageShow("Failed to open camera", True)
	End If
End Sub

Sub PrepareSurface As ResumableSub

	cam.PreviewSize.Initialize(1920, 1080)
	Wait For (cam.PrepareSurface(MyTaskIndex)) Complete (Success As Boolean)
	
	If Success Then cam.StartPreview(MyTaskIndex, False)
	Return Success
	
End Sub

Sub HandleError (Error As Exception)
	Log("error not picture taken ...   " & Error)
	ToastMessageShow(Error, True)
	OpenCamera(True)
End Sub

Sub TakePicture
	Try
		Wait For(cam.FocusAndTakePicture(MyTaskIndex)) Complete (Data() As Byte)
		cam.DataToFile(Data, VideoFileDir, "1.jpg")
		Dim bmp As Bitmap = cam.DataToBitmap(Data)
		Log("Picture taken: " & bmp) 'ignore
		
		'@@@@@@@@@@
		'pnlCamera.SetBackgroundImage(bmp.Resize(pnlCamera.Width, pnlCamera.Height, True)).Gravity = Gravity.CENTER
        
		ImageView1.Bitmap = RotateJpegIfNeeded(bmp, Data)
		Sleep(4000)
	Catch
		HandleError(LastException)
	End Try
	
End Sub
'
Private Sub RotateJpegIfNeeded (bmp As B4XBitmap, Data() As Byte) As B4XBitmap
	Dim p As Phone
	If p.SdkVersion >= 24 Then
		Dim ExifInterface As JavaObject
		Dim in As InputStream
		in.InitializeFromBytesArray(Data, 0, Data.Length)
		ExifInterface.InitializeNewInstance("android.media.ExifInterface", Array(in))
		Dim orientation As Int = ExifInterface.RunMethod("getAttribute", Array("Orientation"))
		Select orientation
			Case 3  '180
				bmp = bmp.Rotate(180)
			Case 6 '90
				bmp = bmp.Rotate(90)
			Case 8 '270
				bmp = bmp.Rotate(270)
		End Select
		in.Close
	End If
	Return bmp
End Sub